/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Unsafe.xs. Do not edit this file, edit Unsafe.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Signal/Unsafe.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define MY_CXT_KEY "Signal::Unsafe" XSVERSION
typedef struct {
	CV* handlers[NSIG];
} my_cxt_t;

START_MY_CXT;

typedef int SysRet;

#define add_iv(name) hv_stores(args, #name, newSViv(info->si_##name))
#define add_uv(name) hv_stores(args, #name, newSVuv(info->si_##name))
#define add_ptr(name) hv_stores(args, #name, newSVuv(PTR2UV(info->si_##name)))

#ifndef si_int
#define si_int si_value.sival_int
#endif
#ifndef si_ptr
#define si_ptr si_value.sival_ptr
#endif

static SV* S_make_args(pTHX_ siginfo_t* info) {
	HV* args = newHV();
	add_iv(signo);
	add_iv(errno);
	add_iv(code);
#ifdef si_utime
	add_uv(utime);
	add_uv(stime);
#endif
	add_iv(pid);
	add_iv(uid);
	add_iv(status);
	add_ptr(addr);
	add_iv(int);
	add_ptr(ptr);
#ifdef si_timerid
	add_iv(timerid);
	add_iv(overrun);
#endif
#if defined(si_fd) && !defined(__OpenBSD__)
	add_iv(fd);
	add_iv(band);
#endif
	return newRV_noinc((SV*)args);
}
#define make_args(info) S_make_args(aTHX_ info)

static void smart_handler(int signo, siginfo_t* info, void* context) {
	dTHX;
	dMY_CXT;
	dSP;
	CV* callback = MY_CXT.handlers[signo];
	if (!callback) {
		Perl_warn(aTHX_ "No handler for signal %d", signo);
		return;
	}
    PUSHSTACKi(PERLSI_SIGNAL);
	SAVETMPS;
	PUSHMARK(SP);
	EXTEND(SP, 3);
	PUSHs(sv_2mortal(newSViv(signo)));
	PUSHs(sv_2mortal(make_args(info)));
	PUSHs(sv_2mortal(newSVpvn((const char*)info, sizeof *info)));
	PUTBACK;
	call_sv((SV*)callback, G_VOID | G_DISCARD);
	FREETMPS;
	POPSTACK;
}

static void dumb_handler(int signo) {
	dTHX;
	dMY_CXT;
	dSP;
	CV* callback = MY_CXT.handlers[signo];
	if (!callback) {
		Perl_warn(aTHX_ "No handler for signal %d", signo);
		return;
	}
    PUSHSTACKi(PERLSI_SIGNAL);
	SAVETMPS;
	PUSHMARK(SP);
	EXTEND(SP, 1);
	PUSHs(sv_2mortal(newSViv(signo)));
	PUTBACK;
	call_sv((SV*)callback, G_VOID | G_DISCARD);
	FREETMPS;
	POPSTACK;
}

static HV* S_get_action(pTHX_ SV* input) {
    if(SvTRUE(input)) {
		if(SvROK(input) && sv_isa(input, "POSIX::SigAction"))
			return (HV*)SvRV(input);
		else
			Perl_croak(aTHX_ "Action is not of type POSIX::SigAction: %s", SvPV_nolen(input));
	}
}
#define get_action(input)  S_get_action(aTHX_ input)

static void S_hash_to_sigaction(pTHX_ struct sigaction* ptr, CV** new_handler, HV* values) {
	if (hv_exists(values, "FLAGS", 5)) {
		SV** flags_ptr = hv_fetchs(values, "FLAGS", 0);
		ptr->sa_flags = SvIV(*flags_ptr);
	}
	if (hv_exists(values, "HANDLER", 7)) {
		SV** handler_ptr = hv_fetchs(values, "HANDLER", 0);
		if (!SvOK(*handler_ptr) || strEQ(SvPV_nolen(*handler_ptr), "DEFAULT")) {
			ptr->sa_flags &= ~SA_SIGINFO;
			ptr->sa_handler = SIG_DFL;
		}
		else if (strEQ(SvPV_nolen(*handler_ptr), "IGNORE")) {
			ptr->sa_flags &= ~SA_SIGINFO;
			ptr->sa_handler = SIG_IGN;
		}
		else {
			GV* gv;
			HV* stash;
			*new_handler = sv_2cv(*handler_ptr, &stash, &gv, 0);

			if (ptr->sa_flags & SA_SIGINFO)
				ptr->sa_sigaction = smart_handler;
			else
				ptr->sa_handler = dumb_handler;
		}
	}
	else {
		Perl_croak(aTHX_ "No handler given");
	}

	if (hv_exists(values, "MASK", 4)) {
		SV** mask_ptr = hv_fetchs(values, "MASK", 0);
		if (SvROK(*mask_ptr))
			ptr->sa_mask = *(const sigset_t *) SvPV_nolen(SvRV(*mask_ptr)); // XXX
	}
}
#define hash_to_sigaction(ptr, handler, val) S_hash_to_sigaction(aTHX_ ptr, handler, val)

void S_sigaction_to_hash(pTHX_ struct sigaction* ptr, HV* hash, CV* handler) {
	dMY_CXT;
	SV* mask;

	if ((void*)ptr->sa_sigaction == SIG_DFL)
		hv_stores(hash, "HANDLER", newSVpvs("DEFAULT"));
	else if ((void*)ptr->sa_sigaction == SIG_IGN)
		hv_stores(hash, "HANDLER", newSVpvs("IGNORE"));
	else
		hv_stores(hash, "HANDLER", newRV_inc((SV*)handler));

	hv_stores(hash, "FLAGS", newSVuv(ptr->sa_flags));
#if PERL_VERSION > 15 || PERL_VERSION == 15 && PERL_SUBVERSION > 2
	mask = newSVpvn((const char*)&ptr->sa_mask, sizeof(sigset_t));
#else
	sigset_t* set = PerlMem_malloc(sizeof(sigset_t));
	Copy(&ptr->sa_mask, set, 1, sigset_t);
	mask = newSViv(PTR2IV(set));
#endif
	hv_stores(hash, "MASK", sv_bless(newRV_noinc(mask), gv_stashpvs("POSIX::SigSet", 0)));
}
#define sigaction_to_hash(sig_action, hash, handler) S_sigaction_to_hash(aTHX_ sig_action, hash, handler)

static void remove_handler(pTHX_ void* ptr) {
	SAVEFREESV(*(SV**)ptr);
	*(SV**)ptr = NULL;
}

#line 181 "temp/Unsafe.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 325 "temp/Unsafe.c"

XS_EUPXS(XS_Signal__Unsafe_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Signal__Unsafe_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 179 "lib/Signal/Unsafe.xs"
		Perl_croak(aTHX_ "Cloning is not yet supported...");
#line 336 "temp/Unsafe.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Signal__Unsafe_sigaction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Signal__Unsafe_sigaction)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sig, newaction, oldaction = 0");
    {
	int	sig = (int)SvIV(ST(0))
;
	HV*	newaction = ST(1) && SvOK(ST(1)) ? get_action(ST(1)) : 0;
	HV*	oldaction = items == 3 && SvOK(ST(2)) ? get_action(ST(2)) : 0;
#line 187 "lib/Signal/Unsafe.xs"
		dMY_CXT;
		struct sigaction newact = {0}, oldact = {0};
		CV* oldhandler;
		CV* new_handler = NULL;
#line 358 "temp/Unsafe.c"
	SysRet	RETVAL;
#line 192 "lib/Signal/Unsafe.xs"
		if (newaction)
			hash_to_sigaction(&newact, &new_handler, newaction);

		oldhandler = MY_CXT.handlers[sig];
		if (newaction) {
			if (new_handler) {
				if (MY_CXT.handlers[sig])
					SvREFCNT_dec(MY_CXT.handlers[sig]);
				MY_CXT.handlers[sig] = (CV*)SvREFCNT_inc(new_handler);
			}
			else {
				SAVEDESTRUCTOR_X(&remove_handler, MY_CXT.handlers + sig);
			}
		}
		RETVAL = sigaction(sig, newaction ? &newact : NULL, oldaction ? &oldact : NULL);

		if (oldaction)
			sigaction_to_hash(&oldact, oldaction, oldhandler);
#line 379 "temp/Unsafe.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Signal__Unsafe); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Signal__Unsafe)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Signal::Unsafe::CLONE", XS_Signal__Unsafe_CLONE);
        newXS_deffile("Signal::Unsafe::sigaction", XS_Signal__Unsafe_sigaction);

    /* Initialisation Section */

#line 174 "lib/Signal/Unsafe.xs"
	MY_CXT_INIT;

#line 431 "temp/Unsafe.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

